DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE > Class Template Reference

Base implementation of Discrete Log (DL) group parameters. More...

Inheritance diagram for DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >:

## Public Types

typedef GROUP_PRECOMP | GroupPrecomputation
typedef GROUP_PRECOMP::Element | Element
typedef BASE_PRECOMP | BasePrecomputation
Public Types inherited from DL_GroupParameters< typename GROUP_PRECOMP::Element >
typedef typename GROUP_PRECOMP::Element | Element

## Public Member Functions

const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const
| Retrieves the group precomputation. More...
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
| Retrieves the group precomputation. More...
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
| Retrieves the group precomputation. More...
Public Member Functions inherited from DL_GroupParameters< typename GROUP_PRECOMP::Element >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
virtual const Element & | GetSubgroupGenerator () const
| Retrieves the subgroup generator. More...
virtual void | SetSubgroupGenerator (const Element &base)
| Sets the subgroup generator. More...
virtual Element | ExponentiateBase (const Integer &exponent) const
| Exponentiates the base. More...
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
| Exponentiates an element. More...
virtual const Integer & | GetSubgroupOrder () const=0
| Retrieves the subgroup order. More...
virtual Integer | GetMaxExponent () const=0
| Retrieves the maximum exponent for the group. More...
virtual Integer | GetGroupOrder () const
| Retrieves the order of the group. More...
virtual Integer | GetCofactor () const
| Retrieves the cofactor. More...
virtual unsigned int | GetEncodedElementSize (bool reversible) const=0
| Retrieves the encoded element's size. More...
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const=0
| Encodes the element. More...
virtual Element | DecodeElement (const byte *encoded, bool checkForGroupMembership) const=0
| Decodes the element. More...
virtual Integer | ConvertElementToInteger (const Element &element) const=0
| Converts an element to an Integer. More...
virtual bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const=0
| Check the group for errors. More...
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const=0
| Check the element for errors. More...
virtual bool | FastSubgroupCheckAvailable () const=0
virtual bool | IsIdentity (const Element &element) const=0
| Determines if an element is an identity. More...
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const=0
| Exponentiates a base to multiple exponents. More...
Public Member Functions inherited from GeneratableCryptoMaterial
virtual void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params=g_nullNameValuePairs)
| Generate a random key or crypto parameters. More...
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | AssignFrom (const NameValuePairs &source)=0
| Assign values to this object. More...
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
virtual void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

### template<class GROUP_PRECOMP, class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>, class BASE = DL_GroupParameters<typename GROUP_PRECOMP::Element>>
class DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >

Base implementation of Discrete Log (DL) group parameters.

Template Parameters

  GROUP_PRECOMP | group precomputation class
  BASE_PRECOMP | fixed base precomputation class
  BASE | class or type of an element

Definition at line 1013 of file pubkey.h.

## Member Function Documentation

## GetGroupPrecomputation()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>, class BASE = DL_GroupParameters<typename GROUP_PRECOMP::Element>>

const DL_GroupPrecomputation<Element>& DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >::GetGroupPrecomputation | ( |  | ) | const

inline virtual

Retrieves the group precomputation.

Returns
  a const reference to the group precomputation

Implements DL_GroupParameters< typename GROUP_PRECOMP::Element >.

Definition at line 1024 of file pubkey.h.

## GetBasePrecomputation()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>, class BASE = DL_GroupParameters<typename GROUP_PRECOMP::Element>>

const DL_FixedBasePrecomputation<Element>& DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >::GetBasePrecomputation | ( |  | ) | const

inline virtual

Retrieves the group precomputation.

Returns
  a const reference to the group precomputation using a fixed base

Implements DL_GroupParameters< typename GROUP_PRECOMP::Element >.

Reimplemented in DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

Definition at line 1028 of file pubkey.h.

## AccessBasePrecomputation()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>, class BASE = DL_GroupParameters<typename GROUP_PRECOMP::Element>>

DL_FixedBasePrecomputation<Element>& DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >::AccessBasePrecomputation | ( |  | ) |

inline virtual

Retrieves the group precomputation.

Returns
  a non-const reference to the group precomputation using a fixed base

Implements DL_GroupParameters< typename GROUP_PRECOMP::Element >.

Reimplemented in DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

Definition at line 1032 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h